// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sick_safetyscanners2_interfaces:msg/GeneralSystemState.idl
// generated code does not contain a copyright notice
#include "sick_safetyscanners2_interfaces/msg/detail/general_system_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `safe_cut_off_path`
// Member `non_safe_cut_off_path`
// Member `reset_required_cut_off_path`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
sick_safetyscanners2_interfaces__msg__GeneralSystemState__init(sick_safetyscanners2_interfaces__msg__GeneralSystemState * msg)
{
  if (!msg) {
    return false;
  }
  // run_mode_active
  // standby_mode_active
  // contamination_warning
  // contamination_error
  // reference_contour_status
  // manipulation_status
  // safe_cut_off_path
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->safe_cut_off_path, 0)) {
    sick_safetyscanners2_interfaces__msg__GeneralSystemState__fini(msg);
    return false;
  }
  // non_safe_cut_off_path
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->non_safe_cut_off_path, 0)) {
    sick_safetyscanners2_interfaces__msg__GeneralSystemState__fini(msg);
    return false;
  }
  // reset_required_cut_off_path
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->reset_required_cut_off_path, 0)) {
    sick_safetyscanners2_interfaces__msg__GeneralSystemState__fini(msg);
    return false;
  }
  // current_monitoring_case_no_table_1
  // current_monitoring_case_no_table_2
  // current_monitoring_case_no_table_3
  // current_monitoring_case_no_table_4
  // application_error
  // device_error
  return true;
}

void
sick_safetyscanners2_interfaces__msg__GeneralSystemState__fini(sick_safetyscanners2_interfaces__msg__GeneralSystemState * msg)
{
  if (!msg) {
    return;
  }
  // run_mode_active
  // standby_mode_active
  // contamination_warning
  // contamination_error
  // reference_contour_status
  // manipulation_status
  // safe_cut_off_path
  rosidl_runtime_c__boolean__Sequence__fini(&msg->safe_cut_off_path);
  // non_safe_cut_off_path
  rosidl_runtime_c__boolean__Sequence__fini(&msg->non_safe_cut_off_path);
  // reset_required_cut_off_path
  rosidl_runtime_c__boolean__Sequence__fini(&msg->reset_required_cut_off_path);
  // current_monitoring_case_no_table_1
  // current_monitoring_case_no_table_2
  // current_monitoring_case_no_table_3
  // current_monitoring_case_no_table_4
  // application_error
  // device_error
}

sick_safetyscanners2_interfaces__msg__GeneralSystemState *
sick_safetyscanners2_interfaces__msg__GeneralSystemState__create()
{
  sick_safetyscanners2_interfaces__msg__GeneralSystemState * msg = (sick_safetyscanners2_interfaces__msg__GeneralSystemState *)malloc(sizeof(sick_safetyscanners2_interfaces__msg__GeneralSystemState));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sick_safetyscanners2_interfaces__msg__GeneralSystemState));
  bool success = sick_safetyscanners2_interfaces__msg__GeneralSystemState__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
sick_safetyscanners2_interfaces__msg__GeneralSystemState__destroy(sick_safetyscanners2_interfaces__msg__GeneralSystemState * msg)
{
  if (msg) {
    sick_safetyscanners2_interfaces__msg__GeneralSystemState__fini(msg);
  }
  free(msg);
}


bool
sick_safetyscanners2_interfaces__msg__GeneralSystemState__Sequence__init(sick_safetyscanners2_interfaces__msg__GeneralSystemState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  sick_safetyscanners2_interfaces__msg__GeneralSystemState * data = NULL;
  if (size) {
    data = (sick_safetyscanners2_interfaces__msg__GeneralSystemState *)calloc(size, sizeof(sick_safetyscanners2_interfaces__msg__GeneralSystemState));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sick_safetyscanners2_interfaces__msg__GeneralSystemState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sick_safetyscanners2_interfaces__msg__GeneralSystemState__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sick_safetyscanners2_interfaces__msg__GeneralSystemState__Sequence__fini(sick_safetyscanners2_interfaces__msg__GeneralSystemState__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sick_safetyscanners2_interfaces__msg__GeneralSystemState__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sick_safetyscanners2_interfaces__msg__GeneralSystemState__Sequence *
sick_safetyscanners2_interfaces__msg__GeneralSystemState__Sequence__create(size_t size)
{
  sick_safetyscanners2_interfaces__msg__GeneralSystemState__Sequence * array = (sick_safetyscanners2_interfaces__msg__GeneralSystemState__Sequence *)malloc(sizeof(sick_safetyscanners2_interfaces__msg__GeneralSystemState__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = sick_safetyscanners2_interfaces__msg__GeneralSystemState__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
sick_safetyscanners2_interfaces__msg__GeneralSystemState__Sequence__destroy(sick_safetyscanners2_interfaces__msg__GeneralSystemState__Sequence * array)
{
  if (array) {
    sick_safetyscanners2_interfaces__msg__GeneralSystemState__Sequence__fini(array);
  }
  free(array);
}
