// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sick_safetyscanners2_interfaces:msg/MeasurementData.idl
// generated code does not contain a copyright notice
#include "sick_safetyscanners2_interfaces/msg/detail/measurement_data__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `scan_points`
#include "sick_safetyscanners2_interfaces/msg/detail/scan_point__functions.h"

bool
sick_safetyscanners2_interfaces__msg__MeasurementData__init(sick_safetyscanners2_interfaces__msg__MeasurementData * msg)
{
  if (!msg) {
    return false;
  }
  // number_of_beams
  // scan_points
  if (!sick_safetyscanners2_interfaces__msg__ScanPoint__Sequence__init(&msg->scan_points, 0)) {
    sick_safetyscanners2_interfaces__msg__MeasurementData__fini(msg);
    return false;
  }
  return true;
}

void
sick_safetyscanners2_interfaces__msg__MeasurementData__fini(sick_safetyscanners2_interfaces__msg__MeasurementData * msg)
{
  if (!msg) {
    return;
  }
  // number_of_beams
  // scan_points
  sick_safetyscanners2_interfaces__msg__ScanPoint__Sequence__fini(&msg->scan_points);
}

sick_safetyscanners2_interfaces__msg__MeasurementData *
sick_safetyscanners2_interfaces__msg__MeasurementData__create()
{
  sick_safetyscanners2_interfaces__msg__MeasurementData * msg = (sick_safetyscanners2_interfaces__msg__MeasurementData *)malloc(sizeof(sick_safetyscanners2_interfaces__msg__MeasurementData));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sick_safetyscanners2_interfaces__msg__MeasurementData));
  bool success = sick_safetyscanners2_interfaces__msg__MeasurementData__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
sick_safetyscanners2_interfaces__msg__MeasurementData__destroy(sick_safetyscanners2_interfaces__msg__MeasurementData * msg)
{
  if (msg) {
    sick_safetyscanners2_interfaces__msg__MeasurementData__fini(msg);
  }
  free(msg);
}


bool
sick_safetyscanners2_interfaces__msg__MeasurementData__Sequence__init(sick_safetyscanners2_interfaces__msg__MeasurementData__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  sick_safetyscanners2_interfaces__msg__MeasurementData * data = NULL;
  if (size) {
    data = (sick_safetyscanners2_interfaces__msg__MeasurementData *)calloc(size, sizeof(sick_safetyscanners2_interfaces__msg__MeasurementData));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sick_safetyscanners2_interfaces__msg__MeasurementData__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sick_safetyscanners2_interfaces__msg__MeasurementData__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sick_safetyscanners2_interfaces__msg__MeasurementData__Sequence__fini(sick_safetyscanners2_interfaces__msg__MeasurementData__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sick_safetyscanners2_interfaces__msg__MeasurementData__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sick_safetyscanners2_interfaces__msg__MeasurementData__Sequence *
sick_safetyscanners2_interfaces__msg__MeasurementData__Sequence__create(size_t size)
{
  sick_safetyscanners2_interfaces__msg__MeasurementData__Sequence * array = (sick_safetyscanners2_interfaces__msg__MeasurementData__Sequence *)malloc(sizeof(sick_safetyscanners2_interfaces__msg__MeasurementData__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = sick_safetyscanners2_interfaces__msg__MeasurementData__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
sick_safetyscanners2_interfaces__msg__MeasurementData__Sequence__destroy(sick_safetyscanners2_interfaces__msg__MeasurementData__Sequence * array)
{
  if (array) {
    sick_safetyscanners2_interfaces__msg__MeasurementData__Sequence__fini(array);
  }
  free(array);
}
