// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sick_safetyscanners2_interfaces:srv/FieldData.idl
// generated code does not contain a copyright notice
#include "sick_safetyscanners2_interfaces/srv/detail/field_data__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

bool
sick_safetyscanners2_interfaces__srv__FieldData_Request__init(sick_safetyscanners2_interfaces__srv__FieldData_Request * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
sick_safetyscanners2_interfaces__srv__FieldData_Request__fini(sick_safetyscanners2_interfaces__srv__FieldData_Request * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

sick_safetyscanners2_interfaces__srv__FieldData_Request *
sick_safetyscanners2_interfaces__srv__FieldData_Request__create()
{
  sick_safetyscanners2_interfaces__srv__FieldData_Request * msg = (sick_safetyscanners2_interfaces__srv__FieldData_Request *)malloc(sizeof(sick_safetyscanners2_interfaces__srv__FieldData_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sick_safetyscanners2_interfaces__srv__FieldData_Request));
  bool success = sick_safetyscanners2_interfaces__srv__FieldData_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
sick_safetyscanners2_interfaces__srv__FieldData_Request__destroy(sick_safetyscanners2_interfaces__srv__FieldData_Request * msg)
{
  if (msg) {
    sick_safetyscanners2_interfaces__srv__FieldData_Request__fini(msg);
  }
  free(msg);
}


bool
sick_safetyscanners2_interfaces__srv__FieldData_Request__Sequence__init(sick_safetyscanners2_interfaces__srv__FieldData_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  sick_safetyscanners2_interfaces__srv__FieldData_Request * data = NULL;
  if (size) {
    data = (sick_safetyscanners2_interfaces__srv__FieldData_Request *)calloc(size, sizeof(sick_safetyscanners2_interfaces__srv__FieldData_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sick_safetyscanners2_interfaces__srv__FieldData_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sick_safetyscanners2_interfaces__srv__FieldData_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sick_safetyscanners2_interfaces__srv__FieldData_Request__Sequence__fini(sick_safetyscanners2_interfaces__srv__FieldData_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sick_safetyscanners2_interfaces__srv__FieldData_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sick_safetyscanners2_interfaces__srv__FieldData_Request__Sequence *
sick_safetyscanners2_interfaces__srv__FieldData_Request__Sequence__create(size_t size)
{
  sick_safetyscanners2_interfaces__srv__FieldData_Request__Sequence * array = (sick_safetyscanners2_interfaces__srv__FieldData_Request__Sequence *)malloc(sizeof(sick_safetyscanners2_interfaces__srv__FieldData_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = sick_safetyscanners2_interfaces__srv__FieldData_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
sick_safetyscanners2_interfaces__srv__FieldData_Request__Sequence__destroy(sick_safetyscanners2_interfaces__srv__FieldData_Request__Sequence * array)
{
  if (array) {
    sick_safetyscanners2_interfaces__srv__FieldData_Request__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `fields`
#include "sick_safetyscanners2_interfaces/msg/detail/field__functions.h"
// Member `device_name`
#include "rosidl_runtime_c/string_functions.h"
// Member `monitoring_cases`
#include "sick_safetyscanners2_interfaces/msg/detail/monitoring_case__functions.h"

bool
sick_safetyscanners2_interfaces__srv__FieldData_Response__init(sick_safetyscanners2_interfaces__srv__FieldData_Response * msg)
{
  if (!msg) {
    return false;
  }
  // fields
  if (!sick_safetyscanners2_interfaces__msg__Field__Sequence__init(&msg->fields, 0)) {
    sick_safetyscanners2_interfaces__srv__FieldData_Response__fini(msg);
    return false;
  }
  // device_name
  if (!rosidl_runtime_c__String__init(&msg->device_name)) {
    sick_safetyscanners2_interfaces__srv__FieldData_Response__fini(msg);
    return false;
  }
  // monitoring_cases
  if (!sick_safetyscanners2_interfaces__msg__MonitoringCase__Sequence__init(&msg->monitoring_cases, 0)) {
    sick_safetyscanners2_interfaces__srv__FieldData_Response__fini(msg);
    return false;
  }
  return true;
}

void
sick_safetyscanners2_interfaces__srv__FieldData_Response__fini(sick_safetyscanners2_interfaces__srv__FieldData_Response * msg)
{
  if (!msg) {
    return;
  }
  // fields
  sick_safetyscanners2_interfaces__msg__Field__Sequence__fini(&msg->fields);
  // device_name
  rosidl_runtime_c__String__fini(&msg->device_name);
  // monitoring_cases
  sick_safetyscanners2_interfaces__msg__MonitoringCase__Sequence__fini(&msg->monitoring_cases);
}

sick_safetyscanners2_interfaces__srv__FieldData_Response *
sick_safetyscanners2_interfaces__srv__FieldData_Response__create()
{
  sick_safetyscanners2_interfaces__srv__FieldData_Response * msg = (sick_safetyscanners2_interfaces__srv__FieldData_Response *)malloc(sizeof(sick_safetyscanners2_interfaces__srv__FieldData_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sick_safetyscanners2_interfaces__srv__FieldData_Response));
  bool success = sick_safetyscanners2_interfaces__srv__FieldData_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
sick_safetyscanners2_interfaces__srv__FieldData_Response__destroy(sick_safetyscanners2_interfaces__srv__FieldData_Response * msg)
{
  if (msg) {
    sick_safetyscanners2_interfaces__srv__FieldData_Response__fini(msg);
  }
  free(msg);
}


bool
sick_safetyscanners2_interfaces__srv__FieldData_Response__Sequence__init(sick_safetyscanners2_interfaces__srv__FieldData_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  sick_safetyscanners2_interfaces__srv__FieldData_Response * data = NULL;
  if (size) {
    data = (sick_safetyscanners2_interfaces__srv__FieldData_Response *)calloc(size, sizeof(sick_safetyscanners2_interfaces__srv__FieldData_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sick_safetyscanners2_interfaces__srv__FieldData_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sick_safetyscanners2_interfaces__srv__FieldData_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sick_safetyscanners2_interfaces__srv__FieldData_Response__Sequence__fini(sick_safetyscanners2_interfaces__srv__FieldData_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sick_safetyscanners2_interfaces__srv__FieldData_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sick_safetyscanners2_interfaces__srv__FieldData_Response__Sequence *
sick_safetyscanners2_interfaces__srv__FieldData_Response__Sequence__create(size_t size)
{
  sick_safetyscanners2_interfaces__srv__FieldData_Response__Sequence * array = (sick_safetyscanners2_interfaces__srv__FieldData_Response__Sequence *)malloc(sizeof(sick_safetyscanners2_interfaces__srv__FieldData_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = sick_safetyscanners2_interfaces__srv__FieldData_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
sick_safetyscanners2_interfaces__srv__FieldData_Response__Sequence__destroy(sick_safetyscanners2_interfaces__srv__FieldData_Response__Sequence * array)
{
  if (array) {
    sick_safetyscanners2_interfaces__srv__FieldData_Response__Sequence__fini(array);
  }
  free(array);
}
